#include "LTLParser.h"

#include <iostream>
#include <sstream>

namespace ltl {

LTLParser::LTLParser(const owl::OwlThread& owl) : Parser(owl) { }

LTLParser::~LTLParser() { }

void LTLParser::split_line(const std::string& line, std::vector<std::string>& variables) const {
    std::istringstream iss(line);
    std::string s;
    while (iss >> s) {
        variables.push_back(s);
    }
}

owl::Formula LTLParser::parse_text(
        owl::FormulaFactory& factory,
        const std::string& text,
        std::vector<std::string>& inputs, std::vector<std::string>& outputs
) const {
    std::stringstream ss(text);
    std::string ltl;
    std::string input_line;
    std::string output_line;

    std::getline(ss, ltl);
    std::getline(ss, input_line);
    std::getline(ss, output_line);

    split_line(input_line, inputs);
    split_line(output_line, outputs);

    // Create list of variables for parser
    std::vector<std::string> variables;

    variables.insert(variables.end(), inputs.cbegin(), inputs.cend());
    variables.insert(variables.end(), outputs.cbegin(), outputs.cend());

    // Parse with provided mapping
    return factory.parse(ltl, variables);
}

}
