#pragma once

#include "Parser.h"

namespace ltl {

class LTLParser : public Parser {
private:
    void split_line(const std::string& line, std::vector<std::string>& variables) const;

protected:
    owl::Formula parse_text(
            owl::FormulaFactory& factory,
            const std::string& text,
            std::vector<std::string>& inputs, std::vector<std::string>& outputs
    ) const;

public:
    LTLParser(const owl::OwlThread& owl);
    ~LTLParser();

    TLSF parse(const std::string& input_file, const bool print_formula = false) const;
};

}
