#pragma once

#include "TLSF.h"

#include "owl.h"

namespace ltl {

class Parser {
private:
    const owl::OwlThread& owl;

protected:
    Parser(const owl::OwlThread& owl);

    virtual owl::Formula parse_text(
            owl::FormulaFactory& factory,
            const std::string& text,
            std::vector<std::string>& inputs, std::vector<std::string>& outputs
    ) const = 0;

public:
    virtual ~Parser();

    TLSF parse(const std::string& input_file, const bool print_formula = false) const;
};

}

