#pragma once

#include <string>

#include "owl.h"

namespace ltl {

typedef unsigned long letter_t;

class TLSF {
public:
    const owl::Formula formula;

    const std::vector<std::string> inputs;
    const std::vector<std::string> outputs;

    const letter_t n_inputs;
    const letter_t n_outputs;

    TLSF(
        const owl::Formula formula,
        const std::vector<std::string> inputs,
        const std::vector<std::string> outputs
    ) :
        formula(std::move(formula)),
        inputs(std::move(inputs)),
        outputs(std::move(outputs)),
        n_inputs(inputs.size()),
        n_outputs(outputs.size())
    { }

    ~TLSF() { }
};

}
