#ifndef CL_COMPILE

#pragma once

#endif

// distance_t must be large enough for max_node_id and -max_node_id
typedef cl_int distance_t;

// dist_id_t must be large enough for max_node_id * max_color
typedef cl_uint dist_id_t;

#define DIST_INFINITY           (CL_INT_MAX - 1)
#define DIST_SOLVED             (CL_INT_MAX)

// bit for marking edges
#define MASK_MARKED_EDGE       (~(CL_UINT_MAX >> 1))
#define MASK_UNMARKED_EDGE       (CL_UINT_MAX >> 1)

#define IS_MARKED_EDGE(edge)   ((edge &   MASK_MARKED_EDGE) != 0)
#define IS_UNMARKED_EDGE(edge) ((edge &   MASK_MARKED_EDGE) == 0)
#define MARK_EDGE(edge)         (edge |=  MASK_MARKED_EDGE)
#define UNMARK_EDGE(edge)       (edge &=  MASK_UNMARKED_EDGE)
